/*----------------------------------------------------------------+
|                                                       	  |
|   Trigger: CTRL_PONTO                   			  |
|   Tabela: BATIDACATRACA          				  | 
|                                                       	  |
|   Descrio:							  |
|   Controla a entrada e sada de Funcionrios atravs da catraca |
|								  |
|   Criao:                                       		  |
|   05/03/2008 - Luiz Passos               			  |
|                                                       	  |
+-----------------------------------------------------------------*/


create or replace
TRIGGER CTRL_PONTO
AFTER INSERT 
ON REGISCATRACA FOR EACH ROW
DECLARE
  V_CDEMPRESA    VARCHAR2(02);
  V_CDFUNC       VARCHAR2(10);    
  V_IDSENTIDO    VARCHAR2(01);
  V_VDFUNC       NUMBER;
BEGIN
  SELECT COUNT(CDFUNC) INTO V_VDFUNC FROM PESSOA WHERE NRPESSOA = :NEW.NRPESSOA AND IDTIPOPESSOA='FUN';
  IF (V_VDFUNC = 1)  THEN
  
    BEGIN
      SELECT  FU.CDFUNC, FU.CDEMPRESA
      INTO    V_CDFUNC, V_CDEMPRESA
      FROM    FUNCIONARIO FU, PESSOA PE 
      WHERE   PE.NRPESSOA = :NEW.NRPESSOA AND   PE.IDTIPOPESSOA = 'FUN' AND
              PE.CDFUNC = FU.CDFUNC       AND   PE.CDEMPRESA    = FU.CDEMPRESA;
    EXCEPTION
      WHEN NO_DATA_FOUND THEN
        V_CDFUNC := NULL;
    END;
  
    IF (V_CDFUNC IS NOT NULL) THEN
      IF :NEW.IDREGISCATRACA = 'E' THEN
         V_IDSENTIDO := '1';
      ELSE
         V_IDSENTIDO := '2';
      END IF;
      INSERT INTO BATIDAPONTO
        (CDEMPRESA, CDFUNC, DTBATIDAPTO, IDSENTBATIDA)
      VALUES
        (V_CDEMPRESA, V_CDFUNC, :NEW.DTREGISCATRACA, V_IDSENTIDO);
    END IF;
    
  END IF;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('CTRL_PONTO','5.01.018'); END;
/
